
#include <stdio.h>
#include <string.h>

#include "defs.h"

#include "dump.h"

QWORD p3(_BYTE v) {
	return (v * v * v);
}

signed __int64 __cdecl SHF(unsigned __int8 *a1, int a2)
{
	int i; 
	signed __int64 v4; 

	v4 = 0x2FD2B4LL;
	for (i = 0; i < a2; ++i)
	{
		LODWORD(v4) = a1[i] ^ (unsigned int)v4;
		v4 *= 0x66EC73LL;
	}
	return v4;
}

int main() {

	QWORD totalTry = 0;
	QWORD passedChecks1 = 0;
	QWORD passedChecks2 = 0;
	QWORD passedChecks3 = 0;
	QWORD passedChecks4 = 0;
	QWORD passedChecks5 = 0;
	QWORD passedChecks6 = 0;
	QWORD passedChecks7 = 0;
	QWORD passedChecks8 = 0;

	for (_BYTE v1 = 0; v1 <= 9; v1++) {
		for (_BYTE v2 = 0; v2 <= 9; v2++)
			for (_BYTE v3 = 0; v3 <= 9; v3++)
				for (_BYTE v4 = 0; v4 <= 9; v4++)
					for (_BYTE v5 = 0; v5 <= 9; v5++)
						for (_BYTE v6 = 0; v6 <= 9; v6++)
							for (_BYTE v7 = 0; v7 <= 9; v7++)
								for (_BYTE v8 = 0; v8 <= 9; v8++)
									for (_BYTE v9 = 0; v9 <= 9; v9++)
										for (_BYTE v10 = 0; v10 <= 9; v10++)
											for (_BYTE v11 = 0; v11 <= 9; v11++)
												for (_BYTE v12 = 0; v12 <= 9; v12++) {

													_BYTE vv1 = v1 + 52;
													_BYTE vv2 = v2 + 52;
													_BYTE vv3 = v3 + 52;
													_BYTE vv4 = v4 + 52;
													_BYTE vv5 = v5 + 52;
													_BYTE vv6 = v6 + 52;

													_BYTE vv7 = v7 + 77;
													_BYTE vv8 = v8 + 77;
													_BYTE vv9 = v9 + 77;
													_BYTE vv10 = v10 + 77;
													_BYTE vv11 = v11 + 77;

													_BYTE vv12 = v12 + 34;

													totalTry++;

													if (((p3(vv1) + p3(vv2) + p3(vv3)) & 0xff) == 0x62) {
														passedChecks1++;
														if (((p3(vv4) + p3(vv5) + p3(vv6) + p3(vv7)) & 0xff) == 0x6b) {
															passedChecks2++;
															if (((p3(vv9) + p3(vv10) + p3(vv11) + p3(vv12)) & 0xff) == 0xbf) {
																passedChecks3++;

																// fill values
																g_data[0x1000 * 0 + 0xa] = 7;
																g_data[0x1000 * 1 + 0xa] = vv1;
																g_data[0x1000 * 2 + 0xa] = vv2;
																g_data[0x1000 * 3 + 0xa] = vv3;
																g_data[0x1000 * 4 + 0xa] = vv4;
																g_data[0x1000 * 5 + 0xa] = vv5;
																g_data[0x1000 * 6 + 0xa] = vv6;
																g_data[0x1000 * 7 + 0xa] = vv7;
																g_data[0x1000 * 8 + 0xa] = vv8;
																g_data[0x1000 * 9 + 0xa] = vv9;
																g_data[0x1000 * 10 + 0xa] = vv10;
																g_data[0x1000 * 11 + 0xa] = vv11;
																g_data[0x1000 * 12 + 0xa] = vv12;
																g_data[0x1000 * 13 + 0xa] = 12;

																// check hash

																unsigned __int64 a1 = SHF(g_data, sizeof(g_data));

																char _v4[5];
																
																_v4[0] = a1 - 0x7D;
																_v4[1] = BYTE1(a1) + 0x7C;
																*(_WORD *)&_v4[2] = WORD1(a1) - 0x5100;
																_v4[4] = 0;
																if (!strcmp(_v4, "Flag")) {
																	printf("Flag values: [");
																	printf("7, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, 12]\n",
																		vv1, vv2, vv3, vv4, vv5, vv6, vv7, vv8, vv9, vv10, vv11, vv12);

																}

															}
														}
													}
													
												}
		printf("[~] %d/9, %lld/%lld/%lld/%lld/%lld/%lld\n", v1, passedChecks1, passedChecks2, passedChecks3, passedChecks4,
			passedChecks5, passedChecks6);
	}
	printf("[+] done %lld\n", totalTry);
}

//output:
//[~] 0 / 9, 0 / 0 / 0 / 0 / 0 / 0
//[~] 1 / 9, 0 / 0 / 0 / 0 / 0 / 0
//Flag values : [7, 54, 61, 61, 59, 56, 58, 80, 83, 79, 85, 83, 38, 12]
//[~] 2 / 9, 1000000000 / 1800000 / 7560 / 0 / 0 / 0
//[~] 3 / 9, 1000000000 / 1800000 / 7560 / 0 / 0 / 0
//[~] 4 / 9, 1000000000 / 1800000 / 7560 / 0 / 0 / 0
//[~] 5 / 9, 1000000000 / 1800000 / 7560 / 0 / 0 / 0
//[~] 6 / 9, 1000000000 / 1800000 / 7560 / 0 / 0 / 0
//[~] 7 / 9, 1000000000 / 1800000 / 7560 / 0 / 0 / 0
//[~] 8 / 9, 1000000000 / 1800000 / 7560 / 0 / 0 / 0
//[~] 9 / 9, 3000000000 / 5400000 / 22680 / 0 / 0 / 0
//[+] done 1000000000000